.\" Copyright (c) 1993 Free Software Foundation, Inc.
.\" See section COPYING for conditions for redistribution
.TH file-pr 8 "April 1993" "GNATS @VERSION@" "GNATS Administration Utilities"
.de BP
.sp
.ti -.2i
\(**
..
.SH NAME
file\-pr \- files incoming problem reports in GNATS database
.SH SYNOPSIS
.hy 0
.na
.B file\-pr
.in +0.5i
[
.B \-d \fIdir\fB | \-\-directory=\fIdir\fB
]
[
\-V | \-\-version
]
.br
[
.B \-l \fIlog-method\fB | \-\-logging=\fIlog-method\fB
]
.br
[
.B \-f \fIfile\fB | \-\-file=\fIfile\fB
]
[
\-D | \-\-debug
]
.ad b
.hy 1
.SH DESCRIPTION
Files incoming bug reports in the 
.B GNATS
database.  Sends mail to appropriate people.  Logs database activity.
.SH OPTIONS
.TP 0.5i
.B \-d \fIdir\fB, \-\-directory=\fIdir\fB
operates on 
.I dir
rather than
.BR @GNATS_ROOT@ .
.TP
.B \-V, \-\-version
.TP
.B \-l \fIlog-method\fB | \-\-logging=\fIlog-method\fB
logs activity according to \fIlog-method\fB, which is one of
.RS
.RS
\fBmail\fR \- mails to gnats\-admin using \fB
.br
\fBsyslog\fR \- forwards to \fBsyslogd\fR(3)
.br
\fBstderr\fR \- prints to stderr
.RE
.RE
.TP
.B \-f \fIfile\fB, \-\-file=\fIfile\fB
accepts
.I file
as input; if this option is not present, standard input is used
.TP
\-D, \-\-debug
turns on debugging messages
.SH FILES
.B @GNATS_ROOT@/*
.br
.B @GNATS_ROOT@/gnats-adm/*
.SH "SEE ALSO"
.BR gnats.texi
and
.BR send-pr.texi ,
which are also installed as GNU
.B Info
files
.B gnats.info
and 
.BR send-pr.info ;
.LP
.BR gnats (l),
.BR send-pr (1),
.BR query-pr (1),
.BR edit-pr (1),
.BR queue-pr (8),
.BR mkcat (8),
.BR rmcat (8),
.BR gen-index (8),
.BR mkdist (8).
.SH COPYING
Copyright (c) 1993 Free Software Foundation, Inc.
.PP
Permission is granted to make and distribute verbatim copies of
this manual provided the copyright notice and this permission notice
are preserved on all copies.
.PP
Permission is granted to copy and distribute modified versions of this
manual under the conditions for verbatim copying, provided that the
entire resulting derived work is distributed under the terms of a
permission notice identical to this one.
.PP
Permission is granted to copy and distribute translations of this
manual into another language, under the above conditions for modified
versions, except that this permission notice may be included in
translations approved by the Free Software Foundation instead of in
the original English.
